diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/visualizer/visualizer/core.py ns-3.47/src/visualizer/visualizer/core.py
--- ns-3.46/src/visualizer/visualizer/core.py	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/visualizer/visualizer/core.py	2026-02-16 16:08:49.843231000 -0800
@@ -83,9 +83,6 @@
     transform_point_simulation_to_canvas,
 )
 
-PI_OVER_2 = math.pi / 2
-PI_TIMES_2 = math.pi * 2
-
 
 ## Node class
 class Node(PyVizObject):
@@ -262,9 +259,9 @@
 
             self.emit("query-extra-tooltip-info", lines)
 
-            mob = ns3_node.GetObject[ns.MobilityModel]()
-            if mob:
-                mobility_model_name = mob.__deref__().GetInstanceTypeId().GetName()
+            mobility = ns3_node.__deref__().GetObject[ns.MobilityModel]()
+            if mobility:
+                mobility_model_name = mobility.__deref__().GetInstanceTypeId().GetName()
                 lines.append("  <b>Mobility Model</b>: %s" % mobility_model_name)
 
             for devI in range(ns3_node.GetNDevices()):
@@ -277,33 +274,51 @@
                 devname = dev.GetInstanceTypeId().GetName()
                 lines.append("    <b>Type:</b> %s" % devname)
 
-                if ipv4 is not None:
+                # Lr-Wpan devices have both 16 bit (short) and 64 bit (extended) addresses unlike other
+                # NetDevices. These are extracted directed from the MAC layer.
+                if devname == "ns3::lrwpan::LrWpanNetDevice":
+                    lines.append(
+                        "    <b>MAC short address:</b> %s" % (dev.GetMac().GetShortAddress(),)
+                    )
+                    lines.append(
+                        "    <b>MAC extended address:</b> %s" % (dev.GetMac().GetExtendedAddress(),)
+                    )
+                elif devname == "ns3::SixLowPanNetDevice":
+                    mac48Addr = ns.Mac48Address.ConvertFrom(dev.GetAddress())
+                    lines.append("    <b>MAC Address:</b> %s (Generated)" % (mac48Addr,))
+                else:
+                    mac48Addr = ns.Mac48Address.ConvertFrom(dev.GetAddress())
+                    lines.append("    <b>MAC Address:</b> %s" % (mac48Addr,))
+
+                if ipv4:
                     ipv4_idx = ipv4.GetInterfaceForDevice(dev)
                     if ipv4_idx != -1:
                         addresses = [
-                            "%s/%s"
-                            % (
+                            "%s/%s (Subnet Mask: %s)"
+                            % (  # Note, Mask and prefix functions names might change. See !2645
                                 ipv4.GetAddress(ipv4_idx, i).GetLocal(),
+                                ipv4.GetAddress(ipv4_idx, i).GetMask().GetPrefixLength(),
                                 ipv4.GetAddress(ipv4_idx, i).GetMask(),
                             )
                             for i in range(ipv4.GetNAddresses(ipv4_idx))
                         ]
                         lines.append("    <b>IPv4 Addresses:</b> %s" % "; ".join(addresses))
-
-                if ipv6 is not None:
+                if ipv6:
                     ipv6_idx = ipv6.GetInterfaceForDevice(dev)
                     if ipv6_idx != -1:
-                        addresses = [
-                            "%s/%s"
-                            % (
-                                ipv6.GetAddress(ipv6_idx, i).GetAddress(),
-                                ipv6.GetAddress(ipv6_idx, i).GetPrefix(),
-                            )
-                            for i in range(ipv6.GetNAddresses(ipv6_idx))
-                        ]
-                        lines.append("    <b>IPv6 Addresses:</b> %s" % "; ".join(addresses))
+                        n = ipv6.GetNAddresses(ipv6_idx)
 
-                lines.append("    <b>MAC Address:</b> %s" % (dev.GetAddress(),))
+                        if n > 0:
+                            # First address on the same line as title
+                            entry = ipv6.GetAddress(ipv6_idx, 0)
+                            first_addr = "%s%s" % (entry.GetAddress(), entry.GetPrefix())
+                            lines.append("    <b>IPv6 Addresses:</b> %s" % first_addr)
+
+                        # Remaining addresses aligned under the first address
+                        for i in range(1, n):
+                            entry = ipv6.GetAddress(ipv6_idx, i)
+                            addr = "%s%s" % (entry.GetAddress(), entry.GetPrefix())
+                            lines.append("                                     %s" % addr)
 
             tooltip.set_markup("\n".join(lines))
         finally:
@@ -460,7 +475,7 @@
         try:
             bounds = self.visualizer.canvas.get_bounds()
 
-            (min_x, min_y, max_x, max_y) = bounds
+            min_x, min_y, max_x, max_y = bounds
 
             min_x = min(x, min_x)
             min_y = min(y, min_y)
@@ -678,7 +693,7 @@
         self.go.clear()
         self.target_time = 0  # in seconds
         self.quit = False
-        self.sim_helper = ns.PyViz()
+        self.sim_helper = ns.visualizer.PyViz()
         self.pause_messages = []
 
     def set_nodes_of_interest(self, nodes):
@@ -703,30 +718,45 @@
         @return none
         """
         while not self.quit:
-            # print "sim: Wait for go"
-            self.go.wait()  # wait until the main (view) thread gives us the go signal
-            self.go.clear()
-            if self.quit:
-                break
-            # self.go.clear()
-            # print "sim: Acquire lock"
-            self.lock.acquire()
             try:
-                if 0:
-                    if ns3.Simulator.IsFinished():
-                        self.viz.play_button.set_sensitive(False)
+                # Wait until the GUI gives the go signal
+                self.go.wait()
+                self.go.clear()
+
+                if self.quit:
+                    break
+
+                # Check once whether GUI main loop is alive
+                gui_active = Gtk.main_level() > 0
+
+                # Thread-safe region (original code)
+                self.lock.acquire()
+                try:
+                    # Advance simulator to the requested target time
+                    self.sim_helper.SimulatorRunUntil(ns.Seconds(self.target_time))
+
+                    # Collect pause messages
+                    self.pause_messages.extend(self.sim_helper.GetPauseMessages())
+
+                    # Schedule GUI update — but only if GUI still exists
+                    if gui_active:
+                        GLib.idle_add(self.viz.update_model, priority=PRIORITY_UPDATE_MODEL)
+
+                    # Check stop condition
+                    if (
+                        ns.Simulator.Now().GetSeconds()
+                        >= self.sim_helper.GetSimulatorStopTime().GetSeconds()
+                    ):
+                        if gui_active:
+                            GLib.idle_add(self.viz._on_simulation_finished)
                         break
-                # print "sim: Current time is %f; Run until: %f" % (ns3.Simulator.Now ().GetSeconds (), self.target_time)
-                # if ns3.Simulator.Now ().GetSeconds () > self.target_time:
-                #    print "skipping, model is ahead of view!"
-                self.sim_helper.SimulatorRunUntil(ns.Seconds(self.target_time))
-                # print "sim: Run until ended at current time: ", ns3.Simulator.Now ().GetSeconds ()
-                self.pause_messages.extend(self.sim_helper.GetPauseMessages())
-                GLib.idle_add(self.viz.update_model, priority=PRIORITY_UPDATE_MODEL)
-                # print "sim: Run until: ", self.target_time, ": finished."
-            finally:
-                self.lock.release()
-            # print "sim: Release lock, loop."
+
+                finally:
+                    self.lock.release()
+
+            except Exception:
+                # Happens if GUI is already shutting down and idle_add crashes internally
+                break
 
 
 ## ShowTransmissionsMode
@@ -1039,6 +1069,7 @@
 
     def create_gui(self):
         self.window = Gtk.Window()
+        self.window.set_title(sys.argv[0])
         vbox = Gtk.VBox()
         vbox.show()
         self.window.add(vbox)
@@ -1373,7 +1404,7 @@
         bounds_x2, bounds_y2 = self.canvas.convert_from_pixels(
             hadj.get_value() + hadj.get_page_size(), vadj.get_value() + vadj.get_page_size()
         )
-        ns.PyViz.LineClipping(
+        ns.visualizer.PyViz.LineClipping(
             bounds_x1, bounds_y1, bounds_x2, bounds_y2, pos1_x, pos1_y, pos2_x, pos2_y
         )
         return (pos1_x.value + pos2_x.value) / 2, (pos1_y.value + pos2_y.value) / 2
@@ -1435,10 +1466,16 @@
                 visibility_threshold=0.5,
                 font=("Sans Serif %f" % int(1 + BITRATE_FONT_SIZE * k)),
             )
+
             angle = math.atan2((pos2_y - pos1_y), (pos2_x - pos1_x))
-            if -PI_OVER_2 <= angle <= PI_OVER_2:
+            if angle > math.pi / 2 or angle < -math.pi / 2:
+                # Normalize the angle, in essence, adjust the angle to keep
+                # it from rotating beyond +/- 90 degrees. In this way, the
+                # direction of the label remain always readable regardless of
+                # the angle.
+                angle += math.pi
                 label.set_properties(
-                    text=("%.2f kbit/s →" % (kbps,)),
+                    text=("← %.2f kbit/s" % (kbps,)),
                     alignment=Pango.Alignment.CENTER,
                     anchor=GooCanvas.CanvasAnchorType.S,
                     x=0,
@@ -1446,7 +1483,7 @@
                 )
             else:
                 label.set_properties(
-                    text=("← %.2f kbit/s" % (kbps,)),
+                    text=("%.2f kbit/s →" % (kbps,)),
                     alignment=Pango.Alignment.CENTER,
                     anchor=GooCanvas.CanvasAnchorType.N,
                     x=0,
@@ -1544,6 +1581,20 @@
 
         self._drop_arrows = new_arrows + old_arrows
 
+    def _on_simulation_finished(self):
+        print("Simulation finished.")
+        if self._update_timeout_id is not None:
+            idExists = GLib.MainContext.default().find_source_by_id(self._update_timeout_id)
+            if idExists:
+                try:
+                    GLib.Source.remove(self._update_timeout_id)
+                except Exception:
+                    pass
+                finally:
+                    self._update_timeout_id = None
+        self.play_button.set_active(False)
+        self.play_button.set_sensitive(False)
+
     def update_view_timeout(self):
         # print "view: update_view_timeout called at real time ", time.time()
 
@@ -1585,7 +1636,14 @@
 
     def _start_update_timer(self):
         if self._update_timeout_id is not None:
-            GLib.source_remove(self._update_timeout_id)
+            idExists = GLib.MainContext.default().find_source_by_id(self._update_timeout_id)
+            if idExists:
+                try:
+                    GLib.Source.remove(self._update_timeout_id)
+                except Exception:
+                    pass
+                finally:
+                    self._update_timeout_id = None
         # print "start_update_timer"
         self._update_timeout_id = GLib.timeout_add(
             int(SAMPLE_PERIOD / min(self.speed, 1) * 1e3),
@@ -1598,12 +1656,26 @@
             self._start_update_timer()
         else:
             if self._update_timeout_id is not None:
-                GLib.source_remove(self._update_timeout_id)
+                idExists = GLib.MainContext.default().find_source_by_id(self._update_timeout_id)
+                if idExists:
+                    try:
+                        GLib.Source.remove(self._update_timeout_id)
+                    except Exception:
+                        pass
+                    finally:
+                        self._update_timeout_id = None
 
     def _quit(self, *dummy_args):
         if self._update_timeout_id is not None:
-            GLib.source_remove(self._update_timeout_id)
-            self._update_timeout_id = None
+            idExists = GLib.MainContext.default().find_source_by_id(self._update_timeout_id)
+            if idExists:
+                try:
+                    GLib.Source.remove(self._update_timeout_id)
+                except Exception:
+                    pass
+                finally:
+                    self._update_timeout_id = None
+        ns.Simulator.Stop()
         self.simulation.quit = True
         self.simulation.go.set()
         self.simulation.join()
@@ -1718,12 +1790,12 @@
         self.simulation.lock.acquire()
         try:
             ns3_node = ns.NodeList.GetNode(node.node_index)
-            mob = ns3_node.GetObject[ns.MobilityModel]()
-            if not mob:
+            mobility = ns3_node.GetObject[ns.MobilityModel]()
+            if not mobility:
                 return
             if self.node_drag_state is not None:
                 return
-            pos = ns3_node.GetObject[ns.MobilityModel]().__deref__().GetPosition()
+            pos = mobility.__deref__().GetPosition()
         finally:
             self.simulation.lock.release()
         devpos = self.canvas.get_window().get_device_position(event.device)
@@ -1737,8 +1809,8 @@
         self.simulation.lock.acquire()
         try:
             ns3_node = ns.NodeList.GetNode(node.node_index)
-            mob = ns3_node.GetObject[ns.MobilityModel]()
-            if not mob:
+            mobility = ns3_node.GetObject[ns.MobilityModel]()
+            if not mobility:
                 return False
             if self.node_drag_state is None:
                 return False
@@ -1746,11 +1818,11 @@
             canvas_x, canvas_y = self.canvas.convert_from_pixels(devpos.x, devpos.y)
             dx = canvas_x - self.node_drag_state.canvas_x0
             dy = canvas_y - self.node_drag_state.canvas_y0
-            pos = mob.GetPosition()
+            pos = mobility.GetPosition()
             pos.x = self.node_drag_state.sim_x0 + transform_distance_canvas_to_simulation(dx)
             pos.y = self.node_drag_state.sim_y0 + transform_distance_canvas_to_simulation(dy)
             # print "SetPosition(%G, %G)" % (pos.x, pos.y)
-            mob.SetPosition(pos)
+            mobility.SetPosition(pos)
             node.set_position(*transform_point_simulation_to_canvas(pos.x, pos.y))
         finally:
             self.simulation.lock.release()
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/visualizer/visualizer/ipython_view.py ns-3.47/src/visualizer/visualizer/ipython_view.py
--- ns-3.46/src/visualizer/visualizer/ipython_view.py	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/visualizer/visualizer/ipython_view.py	2026-02-16 16:08:49.843231000 -0800
@@ -203,7 +203,7 @@
         else:
             if self.no_input_splitter:
                 self.lines.append(line)
-                (status, self.indent_spaces) = self.IP.check_complete("\n".join(self.lines))
+                status, self.indent_spaces = self.IP.check_complete("\n".join(self.lines))
                 self.iter_more = status == "incomplete"
             else:
                 self.IP.input_splitter.push(line)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/CMakeLists.txt ns-3.47/src/wifi/CMakeLists.txt
--- ns-3.46/src/wifi/CMakeLists.txt	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/CMakeLists.txt	2026-02-16 16:08:49.843231000 -0800
@@ -167,7 +167,6 @@
     model/wifi-ru.cc
     model/wifi-spectrum-phy-interface.cc
     model/wifi-spectrum-signal-parameters.cc
-    model/wifi-standard-constants.cc
     model/wifi-standards.cc
     model/wifi-tx-current-model.cc
     model/wifi-tx-parameters.cc
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/examples/wifi-bianchi.cc ns-3.47/src/wifi/examples/wifi-bianchi.cc
--- ns-3.46/src/wifi/examples/wifi-bianchi.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/examples/wifi-bianchi.cc	2026-02-16 16:08:49.851230900 -0800
@@ -45,15 +45,24 @@
 
 #include <fstream>
 #include <iomanip>
+#include <numbers>
 #include <vector>
 
-/// Avoid std::numbers::pi because it's C++20
-#define PI 3.1415926535
+/**
+ * @file
+ * Example comparing ns-3 to the Bianchi model.
+ *
+ * See the Wi-Fi Module documentation in the Models chapter.
+ */
 
 NS_LOG_COMPONENT_DEFINE("WifiBianchi");
 
 using namespace ns3;
 
+/** Unnamed namespace, to disambiguate class Experiment. */
+namespace
+{
+
 std::ofstream cwTraceFile;      ///< File that traces CW over time
 std::ofstream backoffTraceFile; ///< File that traces backoff over time
 std::ofstream phyTxTraceFile;   ///< File that traces PHY transmissions  over time
@@ -2409,6 +2418,9 @@
      * @param staTxPower the STA transmit power
      * @param pktInterval the packet interval
      * @return 0 if all went well
+     *
+     * Call graph was not generated because of its size.
+     * @hidecallgraph
      */
     int Run(const WifiHelper& wifi,
             const YansWifiPhyHelper& wifiPhy,
@@ -2536,8 +2548,8 @@
     const auto angle = (static_cast<degree_u>(360) / (nNodes - 1));
     for (uint32_t i = 0; i < (nNodes - 1); ++i)
     {
-        positionAlloc->Add(Vector(1.0 + (distance * cos((i * angle * PI) / 180)),
-                                  1.0 + (distance * sin((i * angle * PI) / 180)),
+        positionAlloc->Add(Vector(1.0 + (distance * cos((i * angle * std::numbers::pi) / 180)),
+                                  1.0 + (distance * sin((i * angle * std::numbers::pi) / 180)),
                                   0.0));
     }
 
@@ -2843,6 +2855,8 @@
     return count;
 }
 
+} // unnamed namespace
+
 int
 main(int argc, char* argv[])
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/examples/wifi-manager-example.cc ns-3.47/src/wifi/examples/wifi-manager-example.cc
--- ns-3.46/src/wifi/examples/wifi-manager-example.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/examples/wifi-manager-example.cc	2026-02-16 16:08:49.851230900 -0800
@@ -94,7 +94,7 @@
 /// Step structure
 struct Step
 {
-    dBm_u stepSize;  ///< step size
+    dB_u stepSize;   ///< step size
     double stepTime; ///< step size in seconds
 };
 
@@ -198,7 +198,7 @@
     uint32_t steps;
     uint32_t rtsThreshold = 999999; // disabled even for large A-MPDU
     uint32_t maxAmpduSize = 65535;
-    dBm_u stepSize{1};
+    dB_u stepSize{1};
     double stepTime = 1;        // seconds
     uint32_t packetSize = 1024; // bytes
     bool broadcast = false;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/examples/wifi-test-interference-helper.cc ns-3.47/src/wifi/examples/wifi-test-interference-helper.cc
--- ns-3.46/src/wifi/examples/wifi-test-interference-helper.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/examples/wifi-test-interference-helper.cc	2026-02-16 16:08:49.851230900 -0800
@@ -23,7 +23,7 @@
 // The program can be configured at run-time by passing command-line arguments.
 // It enables to configure the delay between the transmission from station A
 // and the transmission from station B (--delay option). It is also possible to
-// select the tx power level (--txPowerA and --txPowerB options), the packet size
+// select the tx power (--txPowerA and --txPowerB options), the packet size
 // (--packetSizeA and --packetSizeB options) and the modulation (--txModeA and
 // --txModeB options) used for the respective transmissions.
 //
@@ -77,8 +77,8 @@
         meter_u xB;            ///< x B
         std::string txModeA;   ///< transmit mode A
         std::string txModeB;   ///< transmit mode B
-        dBm_u txPowerLevelA;   ///< transmit power level A
-        dBm_u txPowerLevelB;   ///< transmit power level B
+        dBm_u txPowerA;        ///< transmit power A
+        dBm_u txPowerB;        ///< transmit power B
         uint32_t packetSizeA;  ///< packet size A
         uint32_t packetSizeB;  ///< packet size B
         uint8_t channelA;      ///< channel number A
@@ -129,7 +129,7 @@
     m_uidA = p->GetUid();
     Ptr<WifiPsdu> psdu = Create<WifiPsdu>(p, hdr);
     WifiTxVector txVector;
-    txVector.SetTxPowerLevel(0); // only one TX power level
+    txVector.SetTxPowerLevel(WIFI_MIN_TX_PWR_LEVEL);
     txVector.SetMode(WifiMode(m_input.txModeA));
     txVector.SetChannelWidth(m_input.widthA);
     txVector.SetPreambleType(m_input.preamble);
@@ -146,7 +146,7 @@
     m_uidB = p->GetUid();
     Ptr<WifiPsdu> psdu = Create<WifiPsdu>(p, hdr);
     WifiTxVector txVector;
-    txVector.SetTxPowerLevel(0); // only one TX power level
+    txVector.SetTxPowerLevel(WIFI_MIN_TX_PWR_LEVEL);
     txVector.SetMode(WifiMode(m_input.txModeB));
     txVector.SetChannelWidth(m_input.widthB);
     txVector.SetPreambleType(m_input.preamble);
@@ -185,8 +185,8 @@
       xB(5),
       txModeA("OfdmRate54Mbps"),
       txModeB("OfdmRate54Mbps"),
-      txPowerLevelA(dBm_u{16.0206}),
-      txPowerLevelB(dBm_u{16.0206}),
+      txPowerA(dBm_u{16.0206}),
+      txPowerB(dBm_u{16.0206}),
       packetSizeA(1500),
       packetSizeB(1500),
       channelA(36),
@@ -225,15 +225,15 @@
     Ptr<WifiNetDevice> devA = CreateObject<WifiNetDevice>();
     m_txA = CreateObject<SpectrumWifiPhy>();
     m_txA->SetDevice(devA);
-    m_txA->SetTxPowerStart(input.txPowerLevelA);
-    m_txA->SetTxPowerEnd(input.txPowerLevelA);
+    m_txA->SetTxPowerStart(input.txPowerA);
+    m_txA->SetTxPowerEnd(input.txPowerA);
 
     Ptr<Node> nodeB = CreateObject<Node>();
     Ptr<WifiNetDevice> devB = CreateObject<WifiNetDevice>();
     m_txB = CreateObject<SpectrumWifiPhy>();
     m_txB->SetDevice(devB);
-    m_txB->SetTxPowerStart(input.txPowerLevelB);
-    m_txB->SetTxPowerEnd(input.txPowerLevelB);
+    m_txB->SetTxPowerStart(input.txPowerB);
+    m_txB->SetTxPowerEnd(input.txPowerB);
 
     Ptr<Node> nodeRx = CreateObject<Node>();
     Ptr<WifiNetDevice> devRx = CreateObject<WifiNetDevice>();
@@ -317,8 +317,8 @@
     cmd.AddValue("xB", "The position of transmitter B (> 0)", input.xB);
     cmd.AddValue("packetSizeA", "Packet size in bytes of transmitter A", input.packetSizeA);
     cmd.AddValue("packetSizeB", "Packet size in bytes of transmitter B", input.packetSizeB);
-    cmd.AddValue("txPowerA", "TX power level of transmitter A", input.txPowerLevelA);
-    cmd.AddValue("txPowerB", "TX power level of transmitter B", input.txPowerLevelB);
+    cmd.AddValue("txPowerA", "TX power of transmitter A", input.txPowerA);
+    cmd.AddValue("txPowerB", "TX power of transmitter B", input.txPowerB);
     cmd.AddValue("txModeA", "Wifi mode used for payload transmission of sender A", input.txModeA);
     cmd.AddValue("txModeB", "Wifi mode used for payload transmission of sender B", input.txModeB);
     cmd.AddValue("channelA", "The selected channel number of sender A", input.channelA);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/helper/athstats-helper.cc ns-3.47/src/wifi/helper/athstats-helper.cc
--- ns-3.46/src/wifi/helper/athstats-helper.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/helper/athstats-helper.cc	2026-02-16 16:08:49.851230900 -0800
@@ -234,10 +234,10 @@
                                   Ptr<const Packet> packet,
                                   WifiMode mode,
                                   WifiPreamble preamble,
-                                  uint8_t txPower)
+                                  uint8_t txPowerLevel)
 {
     NS_LOG_FUNCTION(this << context << packet << "PHYTX mode=" << mode << "Preamble=" << preamble
-                         << "Power=" << txPower);
+                         << "Power level=" << txPowerLevel);
     ++m_phyTxCount;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/helper/athstats-helper.h ns-3.47/src/wifi/helper/athstats-helper.h
--- ns-3.46/src/wifi/helper/athstats-helper.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/helper/athstats-helper.h	2026-02-16 16:08:49.852230800 -0800
@@ -188,13 +188,13 @@
      * @param packet the packet
      * @param mode the WifiMode
      * @param preamble the wifi preamble
-     * @param txPower the transmit power level
+     * @param txPowerLevel the transmit power level
      */
     void PhyTxTrace(std::string context,
                     Ptr<const Packet> packet,
                     WifiMode mode,
                     WifiPreamble preamble,
-                    uint8_t txPower);
+                    uint8_t txPowerLevel);
 
     /**
      * Function to be called when the PHY layer of the considered device
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/helper/wifi-tx-stats-helper.h ns-3.47/src/wifi/helper/wifi-tx-stats-helper.h
--- ns-3.46/src/wifi/helper/wifi-tx-stats-helper.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/helper/wifi-tx-stats-helper.h	2026-02-16 16:08:49.852230800 -0800
@@ -158,7 +158,7 @@
         template <typename Tuple, size_t Index = 0>
         size_t tuple_hash(const Tuple& tuple) const
         {
-            if constexpr (Index < std::tuple_size<Tuple>::value)
+            if constexpr (Index < std::tuple_size_v<Tuple>)
             {
                 size_t seed = tuple_hash<Tuple, Index + 1>(tuple);
                 hash_combine(seed, std::get<Index>(tuple));
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/model/eht/eht-phy.cc ns-3.47/src/wifi/model/eht/eht-phy.cc
--- ns-3.46/src/wifi/model/eht/eht-phy.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/model/eht/eht-phy.cc	2026-02-16 16:08:49.857231000 -0800
@@ -428,6 +428,12 @@
     return dataRate;
 }
 
+uint32_t
+EhtPhy::GetMaxPsduSize() const
+{
+    return WIFI_PSDU_MAX_LENGTH_EHT;
+}
+
 dBm_u
 EhtPhy::Per20MHzCcaThreshold(const Ptr<const WifiPpdu> ppdu) const
 {
@@ -527,7 +533,7 @@
          * aCCATime after the signal starts and shall continue to indicate the 20 MHz subchannel is
          * busy while the threshold continues to be exceeded.
          */
-        dBm_u ccaThreshold = -62;
+        dBm_u ccaThreshold = m_wifiPhy->GetCcaEdThreshold();
         auto delayUntilCcaEnd = GetDelayUntilCcaEnd(ccaThreshold, band);
 
         if (ppdu)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/model/eht/eht-phy.h ns-3.47/src/wifi/model/eht/eht-phy.h
--- ns-3.46/src/wifi/model/eht/eht-phy.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/model/eht/eht-phy.h	2026-02-16 16:08:49.857231000 -0800
@@ -252,6 +252,7 @@
                                 WifiPpduField field) override;
     WifiPhyRxfailureReason GetFailureReason(WifiPpduField field) const override;
     uint32_t GetSigBSize(const WifiTxVector& txVector) const override;
+    uint32_t GetMaxPsduSize() const override;
     dBm_u GetCcaThreshold(const Ptr<const WifiPpdu> ppdu,
                           WifiChannelListType channelType) const override;
     const std::map<MHz_u, WifiChannelListType>& GetCcaSecondaryChannels() const override;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/model/frame-exchange-manager.h ns-3.47/src/wifi/model/frame-exchange-manager.h
--- ns-3.46/src/wifi/model/frame-exchange-manager.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/model/frame-exchange-manager.h	2026-02-16 16:08:49.858230800 -0800
@@ -315,6 +315,7 @@
 
     /**
      * @return the remote station manager operating on our link
+     * @hidecaller
      */
     Ptr<WifiRemoteStationManager> GetWifiRemoteStationManager() const;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/model/he/he-frame-exchange-manager.cc ns-3.47/src/wifi/model/he/he-frame-exchange-manager.cc
--- ns-3.46/src/wifi/model/he/he-frame-exchange-manager.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/model/he/he-frame-exchange-manager.cc	2026-02-16 16:08:49.859231000 -0800
@@ -1516,7 +1516,7 @@
     {
         NS_LOG_LOGIC("AP requested using the max transmit power (" << m_phy->GetTxPowerEnd()
                                                                    << " dBm)");
-        v.SetTxPowerLevel(m_phy->GetNTxPower());
+        v.SetTxPowerLevel(m_phy->GetNTxPowerLevels());
         return v;
     }
 
@@ -1547,7 +1547,7 @@
     auto reqTxPower = dBm_u{static_cast<double>(userInfoIt->GetUlTargetRxPower() + pathLossDb)};
 
     // Convert the transmit power to a power level
-    uint8_t numPowerLevels = m_phy->GetNTxPower();
+    const auto numPowerLevels = m_phy->GetNTxPowerLevels();
     if (numPowerLevels > 1)
     {
         dBm_u step = (m_phy->GetTxPowerEnd() - m_phy->GetTxPowerStart()) / (numPowerLevels - 1);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/model/he/he-phy.cc ns-3.47/src/wifi/model/he/he-phy.cc
--- ns-3.46/src/wifi/model/he/he-phy.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/model/he/he-phy.cc	2026-02-16 16:08:49.860231000 -0800
@@ -1118,11 +1118,13 @@
 }
 
 void
-HePhy::SwitchMaybeToCcaBusy(const Ptr<const WifiPpdu> ppdu)
+HePhy::SwitchMaybeToCcaBusy(const Ptr<const WifiPpdu> ppdu /* = nullptr */)
 {
     NS_LOG_FUNCTION(this);
+
     const auto ccaIndication = GetCcaIndication(ppdu);
     const auto per20MHzDurations = GetPer20MHzDurations(ppdu);
+
     if (ccaIndication.has_value())
     {
         NS_LOG_DEBUG("CCA busy for " << ccaIndication.value().second << " during "
@@ -1130,11 +1132,19 @@
         NotifyCcaBusy(ccaIndication.value().first, ccaIndication.value().second, per20MHzDurations);
         return;
     }
+
     if (ppdu)
     {
-        SwitchMaybeToCcaBusy(nullptr);
+        SwitchMaybeToCcaBusy();
         return;
     }
+
+    // avoid spurious notification if the channel width changed
+    if (m_lastPer20MHzDurations.size() != per20MHzDurations.size())
+    {
+        m_lastPer20MHzDurations.resize(per20MHzDurations.size());
+    }
+
     if (per20MHzDurations != m_lastPer20MHzDurations)
     {
         /*
@@ -1144,6 +1154,12 @@
         NS_LOG_DEBUG("per-20MHz CCA durations changed");
         NotifyCcaBusy(Seconds(0), WIFI_CHANLIST_PRIMARY, per20MHzDurations);
     }
+
+    if (m_wifiPhy->IsStateCcaBusy())
+    {
+        NS_LOG_DEBUG("Update CCA indication to IDLE");
+        m_state->SwitchMaybeToCcaBusy(Seconds(0), WIFI_CHANLIST_PRIMARY, per20MHzDurations);
+    }
 }
 
 void
@@ -1779,7 +1795,7 @@
 uint32_t
 HePhy::GetMaxPsduSize() const
 {
-    return 6500631;
+    return WIFI_PSDU_MAX_LENGTH_HE;
 }
 
 bool
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/wifi/model/he/he-phy.h ns-3.47/src/wifi/model/he/he-phy.h
--- ns-3.46/src/wifi/model/he/he-phy.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/wifi/model/he/he-phy.h	2026-02-16 16:08:49.860231000 -0800
@@ -100,7 +100,7 @@
     Time CalculateTxDuration(const WifiConstPsduMap& psduMap,
                              const WifiTxVector& txVector,
                              WifiPhyBand band) const override;
-    void SwitchMaybeToCcaBusy(const Ptr<const WifiPpdu> ppdu) override;
+    void SwitchMaybeToCcaBusy(const Ptr<const WifiPpdu> ppdu = nullptr) override;
     dBm_u GetCcaThreshold(const Ptr<const WifiPpdu> ppdu,
                           WifiChannelListType channelType) const override;
     void NotifyCcaBusy(const Ptr<const WifiPpdu> ppdu,
